# -*- coding: utf-8 -*-
from setuphelpers import *

r"""
Usable WAPT package functions: install(), uninstall(), session_setup(), audit(), update_package()
{
   "key":"{AB4CE2D7-88FB-4879-899C-91200A553A55}",
   "name":"TheBrain",
   "version":"14.0.101.0",
   "install_date":"2024-07-24 00:00:00",
   "install_location":"",
   "uninstall_string":"MsiExec.exe /I{AB4CE2D7-88FB-4879-899C-91200A553A55}",
   "publisher":"TheBrain Technologies LP",
   "system_component":0,
   "win64":true
  }


{
   "key":"{04A8069A-36CA-4F77-9683-1A99BE2D5A83}",
   "name":"TheBrain",
   "version":"14.0.101.0",
   "install_date":"2024-07-24 00:00:00",
   "install_location":"",
   "uninstall_string":"\"C:\\ProgramData\\Package Cache\\{04A8069A-36CA-4F77-9683-1A99BE2D5A83}\\TheBrain 14.0.101.0 Installer.exe\" /burn.clean.room  /uninstall",
   "publisher":"TheBrain Technologies LP",
   "system_component":0,
   "win64":true
  }
 ]
}
"""
# Declaring global variables - Warnings: 1) WAPT context is only available in package functions; 2) Global variables are not persistent between calls


def install():
    # Declaring local variables
    bin_name = glob.glob('TheBrain*Installer.exe')[0]
    # Installing the software
    
    install_exe_if_needed(bin_name,
        silentflags='-q -overwrite',
        key='{AB4CE2D7-88FB-4879-899C-91200A553A55}',
        min_version=control.get_software_version(),
    )



def uninstall():
    # Définir les clés de registre à désinstaller
    keys_to_uninstall = [
        {
            "key": "{AB4CE2D7-88FB-4879-899C-91200A553A55}",
            "uninstall_string": "MsiExec.exe /I{AB4CE2D7-88FB-4879-899C-91200A553A55} /quiet /norestart"
        },
        {
            "key": "{04A8069A-36CA-4F77-9683-1A99BE2D5A83}",
            "uninstall_string": "\"C:\\ProgramData\\Package Cache\\{04A8069A-36CA-4F77-9683-1A99BE2D5A83}\\TheBrain 14.0.101.0 Installer.exe\" /burn.clean.room /uninstall /quiet /norestart"
        }
    ]

    # Boucle à travers les clés pour désinstaller
    for entry in keys_to_uninstall:
        key = entry["key"]
        uninstall_string = entry["uninstall_string"]
        
        # Vérification si le logiciel est installé en utilisant le nom
        installed = False
        for soft in installed_softwares():
            if soft['key'] == key:
                installed = True
                break
        
        if installed:
            print(f"Désinstallation de TheBrain avec la clé {key}")
            run(uninstall_string)
        else:
            print(f"La clé {key} n'est pas trouvée. Rien à désinstaller pour cette clé.")
